pipeline {
    agent {
        kubernetes {
            label 'ez-joy-friends'
            idleMinutes 5
            yamlFile '../../build-pod.yml'
            defaultContainer 'ez-docker-helm-build'
        }
    }
    environment {
        TAG = 'latest'
        GITLAB_CREDENTIALS = credentials('gitlab-credentials-idan')
        PROJECT_ID = '55047790'
        GITLAB_URL = 'https://gitlab.com'
        MONGO_URI = 'mongodb://mongodb:27017/myrentdb'

    }

    stages {
        stage('Checkout Code') {
            steps {
                checkout scm
            }
        }


        stage('Build Docker Image') {
            steps {
                withCredentials([usernamePassword(credentialsId: 'gitlab-credentials-idan', usernameVariable: 'GITLAB_USERNAME', passwordVariable: 'GITLAB_PASSWORD')]) {
                    script {
                        sh "docker build --build-arg GITLAB_USERNAME=${GITLAB_USERNAME} --build-arg GITLAB_PASSWORD=${GITLAB_PASSWORD} -t idansadi/mycar:latest ."  // Ensure the path is correct
                    }
                }
            echo 'Build Image Completed'
            }
        }

        stage('Test') {
            steps {
                    withCredentials([usernamePassword(credentialsId: 'gitlab-credentials-idan', usernameVariable: 'GITLAB_USERNAME', passwordVariable: 'GITLAB_PASSWORD')]) {
                    script {
                        env.GITLAB_USERNAME = GITLAB_USERNAME
                        env.GITLAB_PASSWORD = GITLAB_PASSWORD
                        sh 'docker-compose -f docker-compose.yml up -d'
                        sh 'docker-compose -f docker-compose.yml run test pytest'
                        sh 'docker-compose -f docker-compose.yml down'
                    }
                }
            }
        }

        stage('Create Merge Request') {
            when {
                not {
                    branch 'master'
                }
            }
            steps {
                script {
                    withCredentials([string(credentialsId: 'gitlab-api-token-idan-new', variable: 'GITLAB_API_TOKEN')]) {
                        def response = sh(script: """
                        curl -s -o response.json -w "%{http_code}" --header "PRIVATE-TOKEN: ${GITLAB_API_TOKEN}" -X POST "${GITLAB_URL}/api/v4/projects/${PROJECT_ID}/merge_requests" \
                        --form "source_branch=${env.BRANCH_NAME}" \
                        --form "target_branch=master" \
                        --form "title=MR from ${env.BRANCH_NAME} into master" \
                        --form "remove_source_branch=false"
                        """, returnStdout: true).trim()
                        if (response.startsWith("20")) {
                            echo "Merge request created successfully."
                        } else {
                            echo "Failed to create merge request. Response Code: ${response}"
                            def jsonResponse = readJSON file: 'response.json'
                            echo "Error message: ${jsonResponse.message}"
                            error "Merge request creation failed."
                        }
                    }
                }
            }
        }

        stage('Login Docker') {
            when {
                    branch 'master'
                }
            steps {
                withCredentials([usernamePassword(credentialsId: 'idan-dockerhub', usernameVariable: 'DOCKERHUB_USERNAME', passwordVariable: 'DOCKERHUB_PASSWORD')]) {
                    sh 'echo $DOCKERHUB_PASSWORD | docker login -u $DOCKERHUB_USERNAME --password-stdin'
                }
                echo 'Login Completed'
            }
        }

        stage('Push Image to Docker Hub') {
            steps {
                sh 'docker push idansadi/mycar:latest'
            }
        }
    }
}

